#ifndef SREL_H
#define SREL_H

#include "suif_inc.h"
#include <omega.h>
#include <vector>
#include "pdg.h"

class symtab_ann;

class SRelation : public Relation {
    symtab_ann	    *sa;
public:
    SRelation (symtab_ann *a) : Relation(0), sa(a) { add_and(); }
    SRelation (SRelation & s) : Relation(s), sa(s.sa) {}
    SRelation (Relation & r, symtab_ann *a) : Relation(r), sa(a) {}
    SRelation (int in, int out, std::vector< std::vector<int> > & c, 
	       symtab_ann *a);
    void fix(var_sym *var, int val);
    void set_infinite(var_sym *var);
    void intersect(named_lin_ineq *nlq);
    void dump();
    std::vector<std::vector<std::vector<int> > > constraints();
    SRelation *Intersection(SRelation *b);
    SRelation *Union(SRelation *b);
    SRelation *Difference(SRelation *b);
    SRelation *Composition(SRelation *b);
    SRelation *Complement();
};

class SMap : public pdg::UnionMap {
public:
    SMap (int in, int out, named_lin_ineq *nli, 
	  std::vector<var_sym *>& globals);
    static void register_type();
};

#endif
