#include <assert.h>
#include "testlib.h"

using pdg::PDG;

int main(int argc, char *argv[])
{
    construct_pdg("testparametric");
    PDG *pdg = get_pn("testparametric");

    assert(pdg->nodes.size() == 5);
    assert(pdg->dependences.size() == 6);
    int registers = 0;
    for (int i = 0; i < pdg->dependences.size(); ++i) {
	pdg::dependence *dep = pdg->dependences[i];
	assert(!dep->reordering);
	assert(!dep->multiplicity);
	assert(dep->value_size);
	if (dep->value_size->v == 1)
	    ++registers;
    }
    assert(registers == 5);

    pdg->free();
    delete pdg;

    return 0;
}
